// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Call the stored procedure getProdCount
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class CallStoredProcedure {

  public static void registerSP(Connection conn) throws SQLException {

	  String dropSP = "DROP PROCEDURE getProdCount";
		String createSP = 
		   "CREATE PROCEDURE getProdCount(OUT PRODCOUNT INT) " + 
       "PARAMETER STYLE JAVA " +
       "READS SQL DATA " +
       "LANGUAGE JAVA EXTERNAL NAME 'StoredProcedure.getProdCount'" ;
			 
    Statement s = conn.createStatement();
  
    try {
      s.execute(dropSP);      
    } 
    catch (SQLException se) {
    }
    s.execute(createSP);
    s.close();			 
	}
	
  public static void main(String argv[]) throws SQLException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
    String title;
    int rows;
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD"); 
			registerSP(conn);
      CallableStatement cstmt = conn.prepareCall("call getProdCount(?)");
      cstmt.registerOutParameter(1, Types.INTEGER);
      cstmt.execute();
      rows = cstmt.getInt(1);
      System.out.println("Rows="+rows);
      cstmt.close();
      conn.close();
    }
    catch (SQLException se) {
      String SQLState = se.getSQLState(); 
      String SQLMessage = se.getMessage();
      System.out.println("Error = "+SQLState);
      System.out.println(SQLMessage);
    }
  }
}