// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// This routine calls a UDF that was created.
// The UDF is registered by this function.
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class CallUDF {
  
  public static void registerUDF(Connection conn) throws SQLException {

	  String dropUDF = "DROP FUNCTION GetPerfDate";
		String createUDF = 
				"CREATE FUNCTION GetPerfDate(Prod_No INT, Min_Seats INT) RETURNS DATE " +
				"PARAMETER STYLE JAVA " +
				"READS SQL DATA LANGUAGE JAVA " + 
				"EXTERNAL NAME 'GetPerformanceUDF.GetPerfDate'" ;
			 
    Statement s = conn.createStatement();
  
    try {
      s.execute(dropUDF);      
    } 
    catch (SQLException se) {
    }
    s.execute(createUDF);
    s.close();			 
	}

  public static void main(String argv[]) throws SQLException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
    String title;
    int rows;
    Date dateGood;
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD"); 
			registerUDF(conn);
      CallableStatement cstmt = conn.prepareCall("{? = CALL GetPerfDate(?,?)}");
      cstmt.registerOutParameter(1, Types.DATE);
      cstmt.setInt(2,2);
      cstmt.setInt(3,10);
      cstmt.execute();
      dateGood = cstmt.getDate(1);
      System.out.println("Date="+dateGood);
      cstmt.close();
      conn.close();
    }
    catch (SQLException se) {
      String SQLState = se.getSQLState(); 
      String SQLMessage = se.getMessage();
      System.out.println("Error = "+SQLState);
      System.out.println(SQLMessage);
    }
  }
}