// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Multiple error checking in a CATCH block
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class CatchSQLError {

  public static void main(String argv[]) throws SQLException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD"); 
      s = conn.createStatement(); 

      rs = s.executeQuery( "SELECT Production_Title FROM Productions_BadTable");

      rs.close(); 
      s.close();
    }

    catch (SQLException se) {
      while (se != null) {
        String SQLState = se.getSQLState(); 
        String SQLMessage = se.getMessage();
        System.out.println("Error = "+SQLState);
        System.out.println(SQLMessage);
        se = se.getNextException();
      }
    }

  }
}