// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Update statement that completes successfully, but no records updated (found).
// The SQLWarning Catch statement should be Result of a catch event on an SQLWarning
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class CheckWarnings {

  public static void main(String argv[]) {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    SQLWarning sw = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD"); 
      s = conn.createStatement(); 
      s.execute("UPDATE PRODUCTIONS SET PRODUCTION_TITLE = 'UNKNOWN' WHERE PRODUCTION_NO = 0");
      sw = s.getWarnings();
      while (sw != null) {
        String SQLState = sw.getSQLState(); 
        String SQLMessage = sw.getMessage();
        System.out.println("Warning = "+SQLState);
        System.out.println(SQLMessage);   
        System.out.println("ErrorCode="+sw.getErrorCode());   
        sw = sw.getNextWarning();
      }
      s.close();
    }

    catch (SQLException se) {
      while (se != null) {
        String SQLState = se.getSQLState(); 
        String SQLMessage = se.getMessage();
        System.out.println("Error = "+SQLState);
        System.out.println(SQLMessage);
        se = se.getNextException();
      }
    }

  }
}