// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Using Updateable cursors in a program
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class CursorUpdateable {

  public static void createTable(Connection conn) throws SQLException {
    
    String tablename = "TESTCURSOR";
    String sqlDROP   = "DROP TABLE " + tablename ;
    String sqlCREATE = "CREATE TABLE " + tablename + " (RECNO INT, RECVAL INT)";
    String sqlINSERT = "INSERT INTO " + tablename + " VALUES (1,1),(2,2),(3,3),(4,4),(5,5)" ;
    Statement s = conn.createStatement();
  
    try {
      s.execute(sqlDROP);      
    } 
    catch (SQLException se) {
    }
    s.execute(sqlCREATE);
    s.execute(sqlINSERT);
    s.close();
  }


  public static void main(String argv[]) throws SQLException, IOException {

    Connection conn = null;
    Statement s = null;
    Statement sd = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
    String title;
    String startDate;
    int rows;
    String search;
    String SQLsearch;
    PreparedStatement ps;
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    conn = DriverManager.getConnection("jdbc:derby:YMLD");  
    conn.setAutoCommit(false);
    createTable(conn);
    s = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE); 
    s.setCursorName("UPDATECURSOR");
    rs = s.executeQuery("SELECT * FROM TESTCURSOR FOR UPDATE");
    ps = conn.prepareStatement("UPDATE TESTCURSOR SET RECVAL=? WHERE CURRENT OF UPDATECURSOR");
    rs.next() ;
    int recNo = rs.getInt("RECNO");
    System.out.println("RECNO=" + recNo);
    ps.setInt(1,100);
    rows = ps.executeUpdate();
    System.out.println("Number of rows updated=" + rows);
    conn.commit();
    rs.close();
    ps.close();
    s.close();
  }
}