// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Retrieve metadata from a cursor
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class GetMetaData {

  public static void main(String argv[]) throws SQLException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
    String title;
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD"); 
      s = conn.createStatement(); 
      s.execute("SET SCHEMA 'APP'");
      rs = s.executeQuery("SELECT * FROM TRANSACTIONS");
      ResultSetMetaData md = rs.getMetaData();
      System.out.println("Column Count=" + md.getColumnCount());
      for (int i = 1; i <= md.getColumnCount(); ++i) {
        System.out.println("--------- Column #" + i + " ---------");
        System.out.println("Catalog Name=" + md.getCatalogName(i));
        System.out.println("Class=" + md.getColumnClassName(i));
        System.out.println("Display size=" + md.getColumnDisplaySize(i));
        System.out.println("Suggested label=" + md.getColumnLabel(i));
        System.out.println("Name=" + md.getColumnName(i));
        System.out.println("Precision=" + md.getPrecision(i));
        System.out.println("Scale=" + md.getScale(i));
        System.out.println("Table schema=" + md.getSchemaName(i));
        System.out.println("Table Name=" + md.getTableName(i));
        System.out.println("Autoincrement=" + md.isAutoIncrement(i));
        System.out.println("Case Sensitive=" + md.isCaseSensitive(i));
        System.out.println("Currency=" + md.isCurrency(i));
        System.out.println("Nullable=" + md.isNullable(i));
        System.out.println("Searchable=" + md.isSearchable(i));
        System.out.println("Signed=" + md.isSigned(i));
      }
      rs.close(); 
      s.close();
    }
    catch (SQLException se) {
      String SQLState = se.getSQLState(); 
      String SQLMessage = se.getMessage();
      System.out.println("Error = "+SQLState);
      System.out.println(SQLMessage);
    }
  }
}