// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// This is a UDF (User-defined Function) that returns the maximum number of seats available for a performance
//
import java.sql.*; 

public class GetPerformanceUDF {

  public static Date GetPerfDate(int Production_no, int Minimum_Seats)
    throws SQLException
  {
  Connection conn = null;
  Statement s = null;
  ResultSet rs = null;
  String SQL = null;
  Date ResultDate = null;

  try
  {
    conn = DriverManager.getConnection("jdbc:default:connection"); 
    s = conn.createStatement(); 
    SQL = 
     "SELECT Performance_Date, max(Performance_Seats) AS Max_Seats " +
     "FROM Performances " +
     "WHERE " +
     "  Production_No =  " + Production_no + " " +
     "GROUP BY " +
     "  Performance_Date " +
     "HAVING " + 
     "  MAX(Performance_Seats) >= " + Minimum_Seats + " " +
     "ORDER BY " + 
     "  Performance_Date ASC";

    rs = s.executeQuery(SQL);
    if (rs.next()) {
      ResultDate = rs.getDate("PERFORMANCE_DATE");
      if (rs.wasNull()) {
        ResultDate = null;
      }
    }
    rs.close(); 
    s.close();
    return ResultDate;
  }
  catch (SQLException se)
    {
    String SQLState = se.getSQLState(); 
    String SQLMessage = se.getMessage();
    System.out.println("Error = "+SQLState);
    System.out.println(SQLMessage);
    return ResultDate;
    }
  }
}