// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Using a parameter marker in a LIKE clause for searching in strings
//

import java.lang.*;
import java.sql.*; 
import java.io.*;

public class LikeSearch {


  public static void main(String argv[]) throws SQLException, IOException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
    String title;
    String startDate;
    int rows;
    String search;
    String SQLsearch;
    PreparedStatement ps;
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    conn = DriverManager.getConnection("jdbc:derby:YMLD");   
    ps = conn.prepareStatement("SELECT * FROM PRODUCTIONS WHERE PRODUCTION_TITLE LIKE ?");
    search = " ";
    while ( search != null ) {
      System.out.print("Enter a title to search for (blank to exit): ");
      search = br.readLine();
      if (search.length() == 0) break;
      SQLsearch = "%"+search+"%";
      ps.setString(1,SQLsearch);
      rs = ps.executeQuery();
      rows = 0;
      while ( rs.next()) {
        if (rows == 0) { 
          System.out.println();
          System.out.println("Productions found");
          System.out.println("-----------------");
        }
        ++rows;
        title = rs.getString("PRODUCTION_TITLE");
        startDate = rs.getString("PRODUCTION_START");
        System.out.println(startDate + " : " + title);
      }
      if (rows == 0) {
        System.out.println("No titles found containing: " + search);
      }
      System.out.println();
      rs.close();
    }     
    ps.close();
  }
}