// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Setting a column to null in a prepare
//

import java.lang.*;
import java.sql.*; 
import java.io.*;

public class NullParameterMarker {

  public static void dropTable(Connection conn, String tablename) throws SQLException {
    
    String sqlDROP   = "DROP TABLE " + tablename ;
    String sqlCREATE = "CREATE TABLE " + tablename + " (C1 INT, C2 INT)";

    Statement s = conn.createStatement();
    try {
      s.execute(sqlDROP);      
    } 
    catch (SQLException se) {
    }
    s.execute(sqlCREATE);
    s.close();
  }


  public static void main(String argv[]) throws SQLException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
    String title;
    int rows;
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD"); 
      dropTable(conn,"TESTPREP");
      PreparedStatement ps = conn.prepareStatement("INSERT INTO TESTPREP VALUES (?, ?)");
      ps.setInt(1,1);
      ps.setNull(2,Types.INTEGER);
      rows = ps.executeUpdate();
      ps.setInt(1,2);
      ps.setInt(2,2);
      rows = ps.executeUpdate();
      ps.close();
    }
    catch (SQLException se) {
      String SQLState = se.getSQLState(); 
      String SQLMessage = se.getMessage();
      System.out.println("Error = "+SQLState);
      System.out.println(SQLMessage);
    }
  }
}