// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Stored procedure that returns a result set of the performances that meet the
// date requirement
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class PerformanceSP {
  
  public static void getPerformances(
    Date startDate, 
    Date endDate, 
    ResultSet[] rsOut) throws SQLException {

    PreparedStatement ps = null;
    Connection conn = null;
    ResultSet rs = null;

    try {
      conn = DriverManager.getConnection("jdbc:default:connection");
      ps = conn.prepareStatement(
        "SELECT Production_Title, Production_Start, Production_End from Productions" +
        " WHERE (? Between Production_Start AND Production_End) OR " +
        "       (? Between Production_Start AND Production_End)") ;
      ps.setDate(1, startDate);
      ps.setDate(2, endDate);
      rsOut[0] = ps.executeQuery();
    }
    catch (SQLException se) {
      String SQLState = se.getSQLState(); 
      String SQLMessage = se.getMessage();
      System.out.println("Error = "+SQLState);
      System.out.println(SQLMessage);
    }
    conn.close();
  }
}