// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Simple result set
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class ResultSetName {


  public static void main(String argv[]) throws SQLException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
    String title;
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD"); 
      s = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY); 
      rs = s.executeQuery(
			  "SELECT Production_No, COUNT(*) AS TOTAL_PROD " +
        "  FROM Performances " +
			  " GROUP BY Production_No");

      rs.next(); // Next record successful
      int perfCount = rs.getInt(2);
      System.out.println("Count = " + perfCount); 
      rs.next();
      perfCount = rs.getInt("TOTAL_PROD");
      System.out.println("Count = " + perfCount);   
      rs.close(); 
      s.close();
    }
    catch (SQLException se) {
      String SQLState = se.getSQLState(); 
      String SQLMessage = se.getMessage();
      System.out.println("Error = "+SQLState);
      System.out.println(SQLMessage);
    }
  }
}