// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Retrieve a BLOB as one long string - Not a good idea if the BLOB is huge!
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class RetrieveBLOB {

  public static void main(String argv[]) throws IOException {

    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
    Connection conn;
    Statement s;
    ResultSet rs;
      
    try {
      Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
      System.out.println("Derby driver not found: " + DerbyDriver);
      NoDriver.printStackTrace();
      System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD");
      s = conn.createStatement();
      rs = s.executeQuery("SELECT SEAT_VIEW FROM SEATMAP WHERE SEAT_NO = 1");
      if (rs.next()) {
        Blob blobOut = rs.getBlob("SEAT_VIEW");
        int blobLength = (int) blobOut.length();
        byte[] completeImage = blobOut.getBytes(1, blobLength);
        FileOutputStream fileOut = new FileOutputStream(".\\COPY.GIF"); 
        fileOut.write(completeImage, 0, blobLength); 
        fileOut.close(); 
      }
      rs.close();
      s.close();
    }
    catch (SQLException se) {
      while (se != null) {
        String SQLState = se.getSQLState(); 
        String SQLMessage = se.getMessage();
        System.out.println("Error = "+SQLState);
        System.out.println(SQLMessage);
        se = se.getNextException();
      }
    }
  }
}