// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Retrieving all of the records in a result set
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class RetrieveResultSet {

  public static void main(String argv[]) throws SQLException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD"); 
      s = conn.createStatement(); 
      rs = s.executeQuery( "SELECT Production_Title FROM Productions");
      System.out.println( "Production Title");  
      while (rs.next()) { 
        String production_title = rs.getString("PRODUCTION_TITLE"); 
        System.out.println( production_title); 
      }
      rs.close(); 
      s.close();
    }
    catch (SQLException se) {
      String SQLState = se.getSQLState(); 
      String SQLMessage = se.getMessage();
      System.out.println("Error = "+SQLState);
      System.out.println(SQLMessage);
    }
  }
}