// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Select all Production data using the network client
//
import java.sql.*; 
import java.io.*;

public class ShowProductionsNetwork {

  public static void main(String argv[]) throws SQLException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "com.ibm.db2.jcc.DB2Driver";
    String DatabaseConnection = "jdbc:derby:net://localhost/YMLD:user=app;password=app;retrieveMessagesFromServerOnGetMessage=true;";
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection(DatabaseConnection); 
      s = conn.createStatement(); 
      s.execute("set schema 'APP'");  
      rs = s.executeQuery( "SELECT Production_Title FROM Productions");
      System.out.println( "Production Title");  
      while (rs.next()) {  
        String production_title = rs.getString("PRODUCTION_TITLE"); 
        System.out.println( production_title); 
      }
      rs.close(); 
      s.close();
    }
    catch (SQLException se) {
      String SQLState = se.getSQLState(); 
      String SQLMessage = se.getMessage();
      System.out.println("Error = "+SQLState);
      System.out.println(SQLMessage);
    }
  }
}