// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Create a Stored Procedure (getProdCount). This class must be compiled and registered into the
// database before being used. The SQL is:
// CREATE PROCEDURE getProdCount(OUT PRODCOUNT INT) 
//  PARAMETER STYLE JAVA 
//  READS SQL DATA 
//  LANGUAGE JAVA EXTERNAL NAME 'UDFS.getProdCount';
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class StoredProcedure {
  
  public static void getProdCount(int[] prodCount) throws SQLException {

    Statement s = null;
    Connection conn = null;
    ResultSet rs = null;

    try {
      conn = DriverManager.getConnection("jdbc:default:connection");
      s = conn.createStatement();
      rs = s.executeQuery("SELECT COUNT(*) FROM PRODUCTIONS");
      rs.next();
      prodCount[0] = rs.getInt(1);
    }
    catch (SQLException se) {
      prodCount[0] = 0;
    }
    finally {
      rs.close();
      s.close();
      conn.close();
    }
  }
}