// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Checking for Nulls
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class TestForNulls {
	
  public static void createTable(Connection conn) throws SQLException {
    
    String tablename = "TESTNULL";
    String sqlDROP   = "DROP TABLE " + tablename ;
    String sqlCREATE = "CREATE TABLE " + tablename + " (C1 INT, C2 INT, C3 VARCHAR(1), C4 VARCHAR(1))";
    String sqlINSERT = "INSERT INTO " + tablename + " VALUES (NULL, 1, NULL, 'A')" ;
    Statement s = conn.createStatement();
  
    try {
      s.execute(sqlDROP);      
    } 
    catch (SQLException se) {
    }
    s.execute(sqlCREATE);
    s.execute(sqlINSERT);
    s.close();
  }

  public static void main(String argv[]) throws SQLException {

    Connection conn = null;
    Statement s = null;
    ResultSet rs = null;
    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
    String title;
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      conn = DriverManager.getConnection("jdbc:derby:YMLD");
			createTable(conn);
      s = conn.createStatement(); 
      rs = s.executeQuery( "SELECT C1, C2, C3, C4 FROM TESTNULL");
      
      rs.next(); 
      int c1 = rs.getInt("C1");
      System.out.println("C1 Value="+c1 + " null=" + rs.wasNull());
      int c2 = rs.getInt("C2");
      System.out.println("C2 Value="+c2 + " null=" + rs.wasNull());
      String c3 = rs.getString("C3");
      System.out.println("C3 Value="+c3 + " null=" + rs.wasNull());
      String c4 = rs.getString("C4");
      System.out.println("C4 Value="+c4 + " null=" + rs.wasNull());
      rs.close(); 
      s.close();
    }
    catch (SQLException se) {
      String SQLState = se.getSQLState(); 
      String SQLMessage = se.getMessage();
      System.out.println("Error = "+SQLState);
      System.out.println(SQLMessage);
    }
  }
}