// 
// Copyright (C) 2005 - George Baklarz, Paul Zikopoulos, Dan Scott
// Apache Derby - Off to the Races
//
// Update a BLOB in the seat database
//
import java.lang.*;
import java.sql.*; 
import java.io.*;

public class UpdateBlob {

  public static void main(String argv[]) {

    String DerbyDriver = "org.apache.derby.jdbc.EmbeddedDriver";
      
    try {
       Class.forName(DerbyDriver).newInstance();
    }
    catch (Exception NoDriver) {
       System.out.println("Derby driver not found: " + DerbyDriver);
       NoDriver.printStackTrace();
       System.exit(1);
    }

    try {
      File fileIn = new File("THEATER.GIF");
      InputStream fis = new FileInputStream(fileIn);
      Connection conn = DriverManager.getConnection("jdbc:derby:YMLD");
      PreparedStatement ps = conn.prepareStatement("UPDATE SEATMAP SET SEAT_VIEW = ? WHERE SEAT_NO = ?");
      ps.setInt(2,1);
      int fileLength = (int) fileIn.length();
      ps.setBinaryStream(1, fis, fileLength);
      ps.executeUpdate();
      ps.close();
    }
    catch (FileNotFoundException fnf) {
      System.out.println("File THEATER.GIF not found");
    }
    catch (SQLException se) {
      while (se != null) {
        String SQLState = se.getSQLState(); 
        String SQLMessage = se.getMessage();
        System.out.println("Error = "+SQLState);
        System.out.println(SQLMessage);
        se = se.getNextException();
      }
    }

  }
}