/*
  CREATE FUNCTION ISQRT(GETSQRT INT) 
    RETURNS INT
    PARAMETER STYLE JAVA 
    NO SQL LANGUAGE JAVA 
    EXTERNAL NAME 'YMLDFunctions.ISQRT';
*/

import java.sql.*; 

public class YMLDFunctions {

  // Normal error handling
  public static int ISQRT(int sqrtvalue) { 
    if (sqrtvalue < 0) throw new IllegalArgumentException();
    return (int)Math.sqrt(sqrtvalue);
  }

  // Custom error code
  public static int IRSQRT(int sqrtvalue) throws SQLException { 
    if (sqrtvalue < 0) throw new SQLException("You need a positive integer!","38500");
    return (int)Math.sqrt(sqrtvalue);
  }


}
